<?php
/*
Plugin Name: Real User IP Enabler
Plugin URI: https://www.alphafactory.co.kr/post/portfolio/real-user-ip-enabler/
Version: 0.1
Author: AlphaFactory
Author URI: https://www.alphafactory.co.kr/
Description: 역방향 프록시 환경에서 사용자의 실제 IP를 가져오도록 해줍니다. <a href=https://codex.wordpress.org/Plugin_API/Filter_Reference/pre_comment_user_ip>사용자 댓글 IP에 대한 워드프레스 코덱스</a> 문서를 참고하여 만들었습니다.
*/

add_filter( 'pre_comment_user_ip', 'auto_reverse_proxy_pre_comment_user_ip');
function auto_reverse_proxy_pre_comment_user_ip()
{
  $REMOTE_ADDR = $_SERVER['REMOTE_ADDR'];
  if (!empty($_SERVER['X_FORWARDED_FOR']))
  {
    $X_FORWARDED_FOR = explode(',', $_SERVER['X_FORWARDED_FOR']);
    if (!empty($X_FORWARDED_FOR))
    {
      $REMOTE_ADDR = trim($X_FORWARDED_FOR[0]);
    }
  }
  elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))
  {
    $HTTP_X_FORWARDED_FOR= explode(',', $_SERVER['HTTP_X_FORWARDED_FOR']);
    if (!empty($HTTP_X_FORWARDED_FOR))
    {
      $REMOTE_ADDR = trim($HTTP_X_FORWARDED_FOR[0]);
    }
  }
  return preg_replace('/[^0-9a-f:\., ]/si', '', $REMOTE_ADDR);
}
